
/*******************************************************************************


     HORIMETRO.C


     AUTOR: CLAUDIO LARIOS

     DATA: 07/08/2015

     COM 5 DIGITOS DE 7 SEGUIMENTOS (0,0 - 9999,9 HORAS)

     APAGA DIGITOS COM ZERO A ESQUERDA
     COM DEZENAS DE MINUTOS CENTESIMAL (6 MIN/UN) NA CASA APS PONTO.
     UTILIZA XTAL DE 4 NHZ

     OBJETIVO: MARCAR HORAS TRABALHADAS EM EQUIPAMENTOS COMO EMPILHADEIRAS,
     MAQUINAS INDUSTRIAIS, ETC, PARA FINS DE MANUTENO PERIDICA.

     OBS. MONTAGEM DE NATUREZA DIDTICA.
     ADAPTADO PARA COMILADOR XC8 EM 26/08/2015
     USE XC8 COMPILER
     ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS


*******************************************************************************/
//            DEFINIO DO USURIO
/******************************************************************************/
//   ESCOLHA O TIPO DE DISPLAY :  CATODO OU ANODO COMUM

   #define  ANODO_COMUM

// Comente para catodo comum

//==============================================================================
//  ESCOLHA SE VAI APARECER OU NO OS ZEROS A ESQUERDA

  #define  NMZ

// DESCOMENTE PARA MOSTRAR OS ZEROS A ESQUERDA
//==============================================================================

#include <xc.h>
#define _XTAL_FREQ 4000000//frequncia usada (osc.interno))

// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

// CONFIG
#pragma config FOSC = HS        // Oscillator Selection bits (HS oscillator: High-speed crystal/resonator on RA6/OSC2/CLKOUT and RA7/OSC1/CLKIN)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable bit (PWRT enabled)
#pragma config MCLRE = ON       // RA5/MCLR/VPP Pin Function Select bit (RA5/MCLR/VPP pin function is MCLR)
#pragma config BOREN = ON       // Brown-out Detect Enable bit (BOD enabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable bit (RB4/PGM pin has digital I/O function, HV on MCLR must be used for programming)
#pragma config CPD = OFF        // Data EE Memory Code Protection bit (Data memory code protection off)
#pragma config CP = OFF         // Flash Program Memory Code Protection bit (Code protection off)





//#bit  led   = 0x05.4 //led opcional (pino 3 ao resistor 1k +led ao vcc)


__EEPROM_DATA(0,0,0,0,0,0,0,0);//situao inicial da eeprom ps programao do pic
//constantes
const char n_dig = 5;//nmero de digitos a ser apresentado

//                         PGFEDCBA   SEGUIMENTOS
//                   PORTB 76543210
const char NUM[] = {     0B00111111,//0
                         0B00000110,//1
                         0B01011011,//2
                         0B01001111,//3
                         0B01100110,//4
                         0B01101101,//5
                         0B01111101,//6
                         0B00000111,//7
                         0B01111111,//8
                         0B01101111 //9
                                          };

//variavis globais

 unsigned char seg,min,minc,hor1,hor2,hor3,hor4,vez,cnt;
 bit f_aux,f_z;


/*==============================================================================
       ROTINA QUE BUSCA VALOR DE MINUTOS GRAVADO EM POSIES DIFERENTES DA
       EEPROM - (AUMENTAR VIDA UTIL DA EEPROM)
==============================================================================*/

char pega_min(){ // valor de minutos poder estar entre posio 4 e 127
   char a;
   for(a=4;a<127;a++){
    if(eeprom_read(a)!=0xff) return (a);//retorna posio onde est 'min'

   }
 }
/*==============================================================================
       ROTINA QUE GRAVA VALOR DE MINUTOS EM POSIES DIFERENTES DA
       EEPROM - (AUMENTAR VIDA UTIL DA EEPROM)
==============================================================================*/

void grava_min(char b){// valor de minutos poder estar entre posio 4 e 127
  if(b<127) {
     eeprom_write((b+1),min);//grava a prxima posio
     eeprom_write (b,0xff);}//apaga a anterior
  else{
      eeprom_write(4,min);//grava no inicio do espao reservado para minutos
    }

}
/*==============================================================================
       ROTINA PARA CONVERTER MINUTOS EM DCIMOS DE HORA (MOSTRA DE 0 - 9),
       SENDO CADA UNIDADE IGUAL A 6 MINUTOS.
==============================================================================*/

void min_cent(){
  char c;
   c=min;
   minc=0;
   while(c>5) {
   c-=6;
   if(++minc>9) minc=0;
   }
}

/*==============================================================================
       ROTINA APAGAMENTO DA EEPROM
 (DESLIGUE A ALIMENTAO. APERTE O BOTO E RELIGUE A ALIMENTAO.)
==============================================================================*/

 void erase_eep(){
 char a;
   TRISA=0b11111111;
   if(PORTA&0b00010000) return;
   for(a=0;a<5;a++){
    eeprom_write(a,0);
   }
   for(a=5;a<128;a++){
    eeprom_write(a,0xff);
   }
   PORTB=0x79; //'E' avisa o apagamento
    #ifdef ANODO_COMUM
    PORTB=0x86;
    #endif
   TRISB=0;
   TRISA=0b00010000;
   PORTA=1;
   __delay_ms(500);
   while(!(PORTA&0b00010000));
   
 }




/*==============================================================================
       ROTINA DE INTERRUPO DO TIMER 0 (OBTEM TEMPO DE 1 SEGUNDO)
==============================================================================*/


 void interrupt  ISR_TIMER0(){
     T0IF=0;//reseta flag over flow do timer 0
     TMR0=TMR0+131;//carga do timer para obter 8ms
   
    if(++cnt>=125){// 8ms * 125= 1seg
       cnt=0;
       if(++seg>59) {
          seg=0;
          f_aux=1;
          if(++min>59) {
            min=0; if(++hor1>9){
              hor1=0; if(++hor2>9){
                 hor2=0; if(++hor3>9) {
                    hor3=0; if(++hor4>9) hor4=0;
                         }
                     }
                 }
             }
         }
     }
 }
 
  
/*==============================================================================
       ROTINA MAIN - CONFIGURAO DE PORTAS E REGISTRADORES
==============================================================================*/


void main() {


   OPTION_REG=5;//TIMER0  COM PRESCALLER /64 
   CMCON=7; //desliga comparadores
   TMR0=131;//PRE-CARGA INICIAL
   cnt=0;//ZERA CONTADOR
   GIE=0;
   erase_eep();
   TRISA=0b11100000;//ajusta sentido das ports
   TRISB=0;//tudo saida
   PORTA=0;//condio inicial
   T0IE=1;//liga interrupo do timer 0
   GIE=1;//liga chave geral das interrupes


   seg=30;//media inicial
   hor1= eeprom_read(0);//retorna valores salvos
   hor2= eeprom_read(1);
   hor3= eeprom_read(2);
   hor4= eeprom_read(3);
   min=  eeprom_read(pega_min());

//==============================================================================
//               LOOP PRINCIPAL DE REPETIO
//==============================================================================

  for(;;){
    min_cent(); //ajusta p/ mostrar dcimos de horas (6min por unidade)
//  rotina de multiplexao dos displays de 7 seguimentos
    if(++vez>=n_dig) vez=0;
    PORTA=PORTA&0xE0;//apaga display
    #ifdef NMZ
    f_z=1;//seta flag de zero a esquerda
    #else
    f_z=0;
    #endif
    switch (vez){

     case 0: {
       PORTB=NUM [hor4];
       #ifdef ANODO_COMUM
       PORTB=~PORTB;
       #endif
       if(!hor4&&f_z)break;
       PORTA= PORTA|8;
       f_z=0;
       break;}
     case 1: {
       PORTB=NUM [hor3];
       #ifdef ANODO_COMUM
       PORTB=~PORTB;
       #endif
       if(!hor3&&f_z)break;
       PORTA= PORTA|4;
       f_z=0;
       break;}
     case 2: {
       PORTB=NUM [hor2];
       #ifdef ANODO_COMUM
       PORTB=~PORTB;
       #endif
       if(!hor2&&f_z)break;
       PORTA= PORTA|2;
       f_z=0;
       break;}
     case 3: {
       PORTB=NUM [hor1];
       PORTB|=0x80; //acende ponto
       #ifdef ANODO_COMUM
       PORTB=~PORTB;
       #endif
       PORTA= PORTA|1;
       break;}

     case 4:{
       PORTB=NUM [minc];
       #ifdef ANODO_COMUM
       PORTB=~PORTB;
       #endif
       PORTA= PORTA|16;
       break;}
      }


 //rotina de salvamento na eeprom de mudanas nos contadores de tempo
    if(f_aux){
      f_aux=0;
      grava_min(pega_min()); //salva mudana em minutos
      if(hor1!=eeprom_read(0)){eeprom_write(0,hor1);} //salva mudana em unidade de horas
      if(hor2!=eeprom_read(1)){eeprom_write(1,hor2);}//salva mudana em dezenas de horas
      if(hor3!=eeprom_read(2)){eeprom_write(2,hor3);}//salva mudana em centenas de horas
      if(hor4!=eeprom_read(3)){eeprom_write(3,hor4);}//salva mudana em milhares de horas
    }
    else{
      __delay_ms(2);//delay de tempo para multiplexao correta


    }

  }
}

